#ifndef __POS_FIXO__
#define __POS_FIXO__

#include <iostream.h>
#include <stdlib.h>
#include "lexico.h"

struct no {
	lexico info;
	no * link;
	no * linkBack;
};

struct Pilha {
	no * top;
};

void init(Pilha &p)
{
	memset(&p, 0, sizeof(Pilha));
}

void push(Pilha &p, lexico a)
{
	no *novo;

	novo = new no;	
	novo->info = a;
	if( p.top != NULL)
		p.top->linkBack = novo;
	novo->link = p.top;
	
	p.top = novo;

}

lexico  pop (Pilha& p)
{
	if(p.top == NULL)
	{
		//cout<< "\nPilha Vazia";
			exit(1);
	}
	lexico v;
	v = p.top ->info;
	no * x;
	x = p.top;
	p.top = p.top->link;
	delete x;
	return v;

}
lexico topo (Pilha& p)
{
	if(p.top == NULL)
	{
		cout<<" \nPilha Vazia";
			exit(1);
	}
	
	return  (p.top) ->info;
}
int vazia(Pilha p)
{
	if(p.top == NULL)
	{
		return 1;
	}
	return 0;
}

void deletaItemExpressao(Pilha &p, lexico *a)
{
	no *x;


	x = p.top;

	while(x != NULL)
	{
		if( &p.top->info == a)
		{
			p.top = p.top->link;
		}	
		else if( &x->info == a && x->link == NULL )
		{
			x->linkBack->link = NULL;
		}
		else if( &x->info == a )
		{
			x->linkBack->link = x->link;
			x->link->linkBack = x->linkBack;
		}
	

		x = x->link;

	}

}

void DuplicarInvPilha(Pilha &antiga, Pilha &nova)
{
	no *novo, *p;

	p = antiga.top;

	while( p != NULL)
	{
		novo = new no;	
		novo->info = p->info;
		if( nova.top != NULL)
			nova.top->linkBack = novo;
		novo->link = nova.top;
		
		nova.top = novo;

		p = p->link;

	}

}

void empilhar(lexico *);

#endif
